"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _webinyModel = require("webiny-model");

var _entities = require("webiny-api/entities");

var _webinyApiSecurity = require("webiny-api-security");

class ColorsModel extends _webinyModel.Model {
  constructor() {
    super();
    this.attr("background").char();
    this.attr("text").char();
  }

}

class PaletteModel extends _webinyModel.Model {
  constructor() {
    super();
    this.attr("popup").model(ColorsModel);
    this.attr("button").model(ColorsModel);
  }

}

class ContentModel extends _webinyModel.Model {
  constructor() {
    super();
    this.attr("href").char();
    this.attr("message").char();
    this.attr("dismiss").char();
    this.attr("link").char();
  }

}

class CookiePolicySettingsModel extends _webinyModel.Model {
  constructor() {
    super();
    this.attr("enabled").boolean();
    this.attr("position").char().setValidators("in:bottom:top:bottom-left:bottom-right").setDefaultValue("bottom");
    this.attr("palette").model(PaletteModel);
    this.attr("content").model(ContentModel);
  }

}

var _default = [{
  name: "graphql-schema-settings-cookie-policy",
  type: "graphql",
  typeDefs: ``,
  resolvers: {},
  security: {
    shield: {
      SettingsMutation: {
        cookiePolicy: (0, _webinyApiSecurity.hasScope)("cms:settings")
      }
    }
  }
}, {
  name: "schema-settings-cookie-policy",
  type: "schema-settings",
  namespace: "cookiePolicy",
  typeDefs:
  /* GraphQL */
  `
            type CookiePolicySettings {
                enabled: Boolean
                policyLink: String
                position: String
                palette: CookiePolicySettingsPalette
                content: CookiePolicySettingsContent
            }

            type CookiePolicySettingsResponse {
                error: Error
                data: CookiePolicySettings
            }

            type CookiePolicySettingsContent {
                href: String
                message: String
                dismiss: String
                link: String
            }

            type CookiePolicySettingsPaletteColors {
                background: String
                text: String
            }

            type CookiePolicySettingsPalette {
                popup: CookiePolicySettingsPaletteColors
                button: CookiePolicySettingsPaletteColors
            }

            input CookiePolicySettingsInput {
                enabled: Boolean
                position: String
                palette: CookiePolicySettingsPaletteInput
                content: CookiePolicySettingsContentInput
            }

            input CookiePolicySettingsPaletteColorsInput {
                background: String
                text: String
            }

            input CookiePolicySettingsPaletteInput {
                popup: CookiePolicySettingsPaletteColorsInput
                button: CookiePolicySettingsPaletteColorsInput
            }

            input CookiePolicySettingsContentInput {
                href: String
                message: String
                dismiss: String
                link: String
            }

            extend type SettingsQuery {
                cookiePolicy: CookiePolicySettingsResponse
            }

            extend type SettingsMutation {
                cookiePolicy(data: CookiePolicySettingsInput): CookiePolicySettingsResponse
            }
        `,
  entity: ({
    cookiePolicy: {
      entities: {
        CookiePolicySettings
      }
    }
  }) => CookiePolicySettings
}, {
  type: "entity",
  name: "entity-cookie-policy-settings",
  namespace: "cookiePolicy",
  entity: {
    name: "CookiePolicySettings",
    factory: (...args) => {
      var _class, _temp;

      return _temp = _class = class CookiePolicySettings extends (0, _entities.settingsFactory)(...args) {
        constructor() {
          super();
          (0, _defineProperty2.default)(this, "data", void 0);
          (0, _defineProperty2.default)(this, "load", void 0);
          this.attr("data").model(CookiePolicySettingsModel);
        }

      }, (0, _defineProperty2.default)(_class, "key", "cookie-policy"), _temp;
    }
  }
}];
exports.default = _default;
//# sourceMappingURL=index.js.map